Package: mergeHMM
Type: Package
Title: Merging states of hidden Markov models.
Version: 1.0
Date: 2013-05-06
Author: Florian Schwaiger
Maintainer: Florian Schwaiger <schwaige@mathematik.uni-marburg.de>
Description: In Holzmann and Schwaiger (2013) hidden Markov models with state-dependent finite mixtures are analyzed. The two proposed algorithms to find an appropriate model and to find density based clusters are here implemented for the uni- and multivariate normal distribution.
License: GPL-2
Depends: methods,sn, mvtnorm, RHmm, parallel, CombMSC
Packaged: 2013-06-13 11:43:35 UTC; schwaige

HMMlogLike <-
function(stateParameters,gamma,x,distribution,...){
  
  m=dim(gamma)[1]
  
  #state dep. as list
  startP = extern2intern(parameter=stateParameters,distribution=distribution,m=m)
  
  if(distribution=="poisson"){
    
    #density
    f0 = function(x,par){lambda=par;return(dpois(x,lambda=lambda))}

    return(HMMlogLikeIntern(stateParameters=startP,gamma,x,f0))
    
  }
  
  if(distribution=="normal"){
    
    #density
    f0 = function(x,par){
      mu    = par[1]
      sigma = par[2]
      return(dnorm(x,mean=mu,sd=sigma))
    }
    
    return(HMMlogLikeIntern(stateParameters=startP,gamma,x,f0))
    
  }
  
  if(distribution=="mv_normal"){
       
    #density
    f0 = function(x,par){
      mu    = par$mu
      sigma = par$sigma
      return(dmnorm(x=x,mean=mu,varcov=sigma))
    }
    

    return(HMMlogLikeIntern(stateParameters=startP,gamma,x,f0))
    
  }
  
}

#definiere Klasse HMM
setClass("hmmClass",representation = representation(transitionMatrix="matrix",
                                                    stateParameters = "list",
                                                    probList = "list",
                                                    internVariables = "list"))
#definiere Klasse normal und MvNormal HMM
setClass("hmmClassNormal",contains="hmmClass",representation = representation(distribution="character"))
setClass("hmmClassMvNormal",contains="hmmClass",representation = representation(distribution="character"))


#define show for normal HMM
setMethod("show",signature(object="hmmClassNormal"),
          function(object){
            r = object@internVariables$r
            
            cat("\n normal HMM:\n")
            cat("------------\n\n")
            
            cat("transition probability matrix:\n")
            tpmCat = format(round(object@transitionMatrix,4),nsmall=4,digits=2,scientific=FALSE)
            for(i in 1:r) cat("\t",tpmCat[i,],"\n")
            cat("\n")
            
            params = round(rbind(object@stateParameters$mu,object@stateParameters$sigma),4)
            paramsCat = format(params,nsmall=2,digits=1,scientific=FALSE)
            
            cat("mixture proportions: \n")
            for(i in 1:r) 
              cat("\t","state ",i,":", format(round(object@probList[[i]],4),nsmall=4,digits=2),"\n")
            cat("\n")
            
            cat("means: \n")
            cat("\t", paramsCat[1,],"\n\n")
            
            cat("standard deviations: \n")
            cat("\t", paramsCat[2,],"\n \n")
            
          }          
)

#define show for normal HMM
setMethod("show",signature(object="hmmClassMvNormal"),
          function(object){
            r = object@internVariables$r
            m = object@internVariables$m
            k = object@internVariables$k
            
            cat("\n multivariate - normal HMM:\n")
            cat(" --------------------------\n\n")
            
            cat("transition probability matrix:\n")
            tpmCat = format(round(object@transitionMatrix,4),nsmall=4,digits=2,scientific=FALSE)
            for(i in 1:r) cat("\t",tpmCat[i,],"\n")
            cat("\n")
            
            cat("mixture proportions: \n")
            for(i in 1:r) 
              cat("\t","state ",i,":", format(round(object@probList[[i]],4),nsmall=4,digits=2),"\n")
            cat("\n")
            
            cat("means: \n")
            formatedMu = format(round(object@stateParameters$mu,4),nsmall=2,digits=1)
            for(i in 1:m)
              cat("\t", formatedMu[i,],"\n")
            cat("\n")
            
            cat("standard deviations: \n")
            formatedSigma = format(round(object@stateParameters$sigma,4),nsmall=2,digits=1)
            for(i in 1:m){
              cat("\t")
              for(j in 1:k){
                if(j<k)
                  cat(formatedSigma[i,,j],"\t|\t")
                else
                  cat(formatedSigma[i,,j])              }
              cat("\n")
            }
            cat("\n")          
          }          
)

mleHMMintern <-
function(x,m,G,f,pn2pw,pw2pn,startParameters,startGamma,...){
    
  #global variables
  nState = length(pn2pw(startParameters[[1]]))
  
  #print(nState)
  
  #calculates stationary distribution
  stat_distr = function(mat){
    m0=dim(mat)[1]
    I_m = diag(rep(1,m0))
    U = matrix(rep(1,m0*m0),nrow=m0)
    M = I_m - mat + U
    One = matrix(rep(1,m0),nrow=1)
    erg = One %*% solve(M)
    return(as.vector(erg))
  }
  
  #given the restriction gamma = lambda_G(gamma)
  # the tpm gamma can be parametrized in nu and pList
  
  #transforms (k x k) tpm to (r x r) tpm and vector of probabilities
  gamma2nuP = function(gamma,G){
    
    #number of sets in partition
    r = length(G)  
    
    #matrix of group transitions
    nu = NA * matrix(0,ncol=r,nrow=r)
    #list of inner group probabilities
    pList = list()
    
    #calculates the probability from group l -> m
    probOfGroupTransition = function(l,m,G,gamma){
      #stationary distribution
      p0 = stat_distr(gamma)
      
      #probability for G_l
      sumGroup_l = sum(p0[G[[l]]])
      
      erg=0
      for(g in G[[m]]){
        for(h in G[[l]]){
          erg = erg + p0[h]/sumGroup_l * gamma[h,g]  
        } 
      }
      return(erg)
    }
    
    
    #set starting parameter for nu matrix
    for(i in 1:r){
      for(j in 1:r){
        nu[i,j] = probOfGroupTransition(l=i,m=j,G=G,gamma=gamma)
      }
    }
    
    #set starting parameter for pList
    p0 = stat_distr(gamma)
    for(l in 1:r){
      pList[[l]] = numeric(length(G[[l]]))
      sumGroup_l = sum(p0[G[[l]]])
      pList[[l]] = p0[G[[l]]]/sumGroup_l
    }
    
    return(list(nu=nu,pList=pList))
    
  }

  #transforms (r x r) tpm and vector of probabilities to (k x k) tpm 
  nuP2Gamma = function(nuPList,G){
    
    nu = nuPList$nu
    pList = nuPList$pList
    m=length(unlist(pList))
    
    getGroupOfIndex = function(i,G){
      r=length(G)
      for(l in 1:r){
        if(any(G[[l]]==i)) return(l)  
      }
    }
    
    getPositionInGroup = function(i,G){  
      group = getGroupOfIndex(i,G)
      return(which(G[[group]]==i))  
    }
    
    
    #set gamma matrix back 
    gamma = NA * matrix(0,ncol=m,nrow=m)
    
    for(i in 1:m){
      for(j in 1:m){
        gamma[i,j] = nu[getGroupOfIndex(i,G),getGroupOfIndex(j,G)] * pList[[getGroupOfIndex(j,G)]][getPositionInGroup(j,G)]  
      }
    }
    
    return(gamma)
    
  }
  
  #transformations to transform from/to restricted/unrestricted parameter space
  # the transformations for tpms and p's are allways the same
  # the transformations for the state dep. parameter depends on the family of the distribution
  
  ####
  #transforms tpm to vector
  tpmPn2pw = function(mat){
    m0  = dim(mat)[1]
    if(m0>1){
      foo = log(mat/diag(mat))
      tmat = as.vector(foo[!diag(m0)])
      return(tmat)  
    }
    else
      return(NULL)
  }
  
  #transforms vector to tpm
  tpmPw2pn = function(param,m0){
    epar = exp(param)
    mat = diag(m0)
    mat[!mat] = epar[1:(m0*m0-m0)]
    mat = mat/apply(mat,1,sum)
    mat
  }
  ####
  
  
  ####
  #transforms list of probability vectors to vector
  probPn2pw = function(pList,G){
    r = length(G)
    param = NULL
    
    for(l in 1:r){
      prob=pList[[l]]
      if(length(prob>1))
        param = c(param, log( prob[-1] / ( 1-sum(prob[-1]) ) ) )
      else
        param = c(param,NULL) 
    }
    return(param)
  }
  
  #transforms vector to list os probability vectors
  probPw2pn = function(param,G){
    pList = list()
    r = length(G)
    epar = exp(param)
    for(l in 1:r){
      if(length(G[[l]])==1)
        pList[[l]]=1
      else{
        nTMP = length(G[[l]])-1 #the first nTMP values of epar are relevant for the present group
        eParTMP = epar[1:nTMP]
        pTMP = eParTMP/(1+sum(eParTMP))
        pList[[l]]=c(1-sum(pTMP),pTMP) 
        epar = epar[-(1:nTMP)]
      }
    }
    return(pList)
  }
  ####
  
  ####
  #transforms all natural state dep. parameters to working parameters
  statePn2pw = function(parameters){
    stateWorking = NULL
    m=length(parameters)
    for(i in 1:m){
      stateWorking = c(stateWorking,pn2pw(parameters[[i]]))  
    }
    return(stateWorking)
  }
  
  #transforms all statedep. working paramaters to natural parameters
  statePw2pn = function(stateWorking){
    
    parameters = list()
    
    for(ind in 1:m){

      parameters[[ind]] = pw2pn(stateWorking[1:nState])
      stateWorking = stateWorking[-(1:nState)]
    }
    
    return(parameters)
  }
  ####
  
  ####
  #transformation of the complete parameter to a unconstranied vector
  allPn2Pw = function(nuPList,parameters,G){
  
    #read values
    r = dim(G)
    nu = nuPList$nu
    pList = nuPList$pList
    m = length(unlist(pList))
    
    
    #set working parameter
    #tpm nu
    workingTpm = tpmPn2pw(nu)
    #pList
    workingPlist = probPn2pw(pList=pList,G=G)
    #state dependent parameter
    workingState = statePn2pw(parameters=parameters)
    
    return(c(workingTpm,workingPlist,workingState))
    
  }
  

  allPw2pn = function(parameter,G){
    
    r = length(G)
    m = length(unlist(G))
    #tpm
    if(r==1){
      nu=matrix(1)
    }
    else{
      nu = tpmPw2pn(param=parameter[1:(r^2-r)],m0=r)
      parameter = parameter[-(1:(r^2-r))]
    }
    

    
    #pList
    z = 0; for(l in 1:r){ nG = length(G[[l]]);if(nG!=1) z=z+nG-1 }
    nParPlist = z

    if(z>0){  
      pList = probPw2pn(param=parameter[1:nParPlist],G=G)
      parameter = parameter[-(1:nParPlist)]
    }
    else{
      pList = probPw2pn(param=0,G=G)  
    }
    
    nuPList = list(nu=nu,pList=pList)
    
    stateParameters = statePw2pn(stateWorking=parameter)
    
    return(list(nuPList=nuPList,stateParameters=stateParameters))
    
  }
  ####
  

  
  norm.HMM.mllk <- function(parvect,x,m,G,...)
  {
    if(m==1) return(-Inf)
    
    #transform working parameters 2 natural parameters
    pn = allPw2pn(parameter=parvect,G=G)
    gamma = nuP2Gamma(nuPList = pn$nuPList, G = G)
    stateParameters = pn$stateParameters
    
    #stationary distribution
    try(delta <- stat_distr(gamma))
    if(class(try(delta <- stat_distr(gamma))) == "try-error")
    delta=rep(1/m,m)
    #print(delta)
    
    #no. of observations
    n = ifelse(test=is.matrix(x),yes=n<-dim(x)[1],no=n<-length(x))
    
    
    #state dependent density values
    allprobs= matrix(NA,ncol=m,nrow=n)
    for(j in 1:m){
      allprobs[,j] = f(x=x,par=stateParameters[[j]])
    }
    
    allprobs   <- ifelse(!is.na(allprobs),allprobs,1)
    lscale     <- 0
    foo        <- delta
    for (i in 1:n)
    {
      foo    <- foo%*%gamma*allprobs[i,]
      sumfoo <- sum(foo)
      lscale <- lscale+log(sumfoo)
      foo    <- foo/sumfoo
    }
    mllk       <- -(lscale)
    mllk
  }  
  
  #print("OK1")
  
  #print(statePn2pw(startParameters))
  
  parvect0 = allPn2Pw(nuPList=gamma2nuP(gamma=startGamma,G=G),parameters=startParameters,G=G)
  
  #print("OK2")
  
  mod = nlm(norm.HMM.mllk,parvect0,x=x,m=m,G=G,...)
  pn        <- allPw2pn(parameter=mod$estimate,G=G)
  mllk      <- mod$minimum
  np        <- length(parvect0)
  AIC       <- 2*(mllk+np)
  n         <- sum(!is.na(x))
  BIC       <- 2*mllk+np*log(n)
  par_est = list(gamma  = nuP2Gamma(nuPList=pn$nuPList,G=G), stateDepParameters = pn$stateParameters)
  
  
  return(list(mle=par_est,code=mod$code,mllk=mllk,AIC=AIC,BIC=BIC))
    
}

HMMlogLikeIntern <-
function(stateParameters,gamma,x,f,...){
  
  m = dim(gamma)[1]
  
  if(m==1) return(-Inf)

  #stationary distribution
  delta = stat_distr(gamma)
  
  #print(delta)
  
  #no. of observations
  n = ifelse(test=is.matrix(x),yes=n<-dim(x)[1],no=n<-length(x))
  
  
  #state dependent density values
  allprobs= matrix(NA,ncol=m,nrow=n)
  for(j in 1:m){
    allprobs[,j] = f(x=x,par=stateParameters[[j]])
  }
  
  allprobs   <- ifelse(!is.na(allprobs),allprobs,1)
  lscale     <- 0
  foo        <- delta
  for (i in 1:n)
  {
    foo    <- foo%*%gamma*allprobs[i,]
    sumfoo <- sum(foo)
    lscale <- lscale+log(sumfoo)
    foo    <- foo/sumfoo
  }
  mllk       <- -(lscale)
  mllk
}

mergeHMM <-
function(hmm,G){

    reOrder = unlist(G)
  
    distribution = hmm@internVariables$distribution
    
    #merged tpm and inner state probs
    nuP = gamma2nuP(hmm@transitionMatrix,G)
    nu=nuP$nu
    pList=nuP$pList
    
    if(distribution=="mv_normal")
      out=setHMM(transitionMatrix=nu,
                 mu=hmm@stateParameters$mu[,reOrder],
                 sigma=hmm@stateParameters$sigma[,,reOrder],
                 probList = pList)
    if(distribution=="normal")
      out=setHMM(transitionMatrix=nu,
                 mu=hmm@stateParameters$mu[reOrder],
                 sigma=hmm@stateParameters$sigma[reOrder],
                 probList = pList)
    return(out)

}

investigateMergedHMMs <-
function(x,hmm,independenceClusters){
  
  
  stateParameters = hmm@stateParameters
  gamma = hmm@transitionMatrix
  distribution = hmm@internVariables$distribution
  
  
  #set no. of states, and number of dep. clusters
  G0 = independenceClusters
  m=length(unlist(G0))
  r0 = length(G0)  
  
  if(r0==m) return("No merging is possible.")
  
  #calculate posiible number of merges
  nMerge = 0
  for(i in 1:r0) nMerge = length(G0[[i]]) - 1 + nMerge 
  
  #initialise path of models
  modelPath = list()
  modelPath[[nMerge+1]] = mergeHMM(hmm=hmm,G=as.list(1:m))
  
  #initialise path of partitions
  GPath = list()
  GPath[[nMerge+1]] = as.list(1:m)
  
  #initialise path of local decoding entropies
  localDecodingEntropies = numeric(nMerge+1)
  localDecodingEntropies[nMerge+1] = 
    localDecodingEntopie(x,hmm,G=as.list(1:m))$entropy
  
  
  #iteratively merge from top to bottom
  for(i in nMerge:1){
    
    #all possible partitions one level lower
    GlistTmp = getNextPartitions(G=GPath[[i+1]],independenceClusters=G0) 
    Btmp = length(GlistTmp)
    
    
    #set a function to use lapply with local decoding entropy
    localDecodingEntropyTmp = function(i,Glist){
      return(localDecodingEntopie(x,hmm,G=Glist[[i]])$entropy)
    }
    
    
    
    #find partition which provides highest drop of local dec. entr.
    parallelOutput = lapply(X=1:Btmp,localDecodingEntropyTmp,Glist=GlistTmp)
    j0 = which.min(unlist(parallelOutput))
    
    
    #set values of merged model
    GPath[[i]] = GlistTmp[[j0]]
    modelPath[[i]] = mergeHMM(hmm=hmm,G=GlistTmp[[j0]])
    localDecodingEntropies[i] = unlist(parallelOutput)[j0]
    
  }
  
  
  return(list(modelPath=rev(modelPath),
              GPath=rev(GPath),
              localDecodingEntropies=rev(localDecodingEntropies)))
  
}

setHMM <-
function(transitionMatrix,mu,sigma,probList = as.list(rep(x=1,times=dim(transitionMatrix)[1]))){
  
  if(dim(transitionMatrix)[1] != length(probList))
    return("Dimension of transitionMatrix and probList does not match!")
  
  #set distribution
  if(class(mu)=="numeric"||class(mu)=="integer")
    {distribution="normal"; m=1}
  if(class(mu)=="matrix")
    {distribution="mv_normal";m = dim(mu)[1]}
  
  r = dim(transitionMatrix)[1]
  k = length(unlist(probList))
  
  G = list()
  j=1
  for(i in 1:r){
    G[[i]] = j:(j+length(probList[[i]])-1)
    j = j+length(probList[[i]])
  }

  internVariables = list(r=r,k=k,G=G,m=m,distribution=distribution)

  if(distribution=="normal")
    outputClass =   return(new("hmmClassNormal",transitionMatrix=transitionMatrix,stateParameters=list(mu=mu, sigma=sigma),
                               probList=probList,internVariables=internVariables,distribution="normal"))
  if(distribution=="mv_normal")
    outputClass =   return(new("hmmClassMvNormal",transitionMatrix=transitionMatrix,stateParameters=list(mu=mu, sigma=sigma),
                               probList=probList,internVariables=internVariables,distribution="mv_normal"))  
  
}

extern2intern <-
function(parameter,distribution,m){
  
  if(distribution=="poisson"){
    return(as.list(parameter))  
  }
  
  if(distribution=="normal"){
    startP = list()
    for(i in 1:m) startP[[i]]=c((parameter$mu)[i],(parameter$sigma)[i])
    return(startP)
  }
  
  if(distribution=="mv_normal"){
    startP = list()
    for(i in 1:m)
      startP[[i]]=list(mu = (parameter$mu)[,i], sigma=(parameter$sigma)[,,i])  
    return(startP)
    }

}

gamma2nuP <-
function(gamma,G){
  
  #number of sets in partition
  r = length(G)  
  
  #matrix of group transitions
  nu = NA * matrix(0,ncol=r,nrow=r)
  #list of inner group probabilities
  pList = list()
  
  #calculates the probability from group l -> m
  probOfGroupTransition = function(l,m,G,gamma){
    #stationary distribution
    p0 = stat_distr(gamma)
    
    #probability for G_l
    sumGroup_l = sum(p0[G[[l]]])
    
    erg=0
    for(g in G[[m]]){
      for(h in G[[l]]){
        erg = erg + p0[h]/sumGroup_l * gamma[h,g]  
      } 
    }
    return(erg)
  }
  
  
  #set starting parameter for nu matrix
  for(i in 1:r){
    for(j in 1:r){
      nu[i,j] = probOfGroupTransition(l=i,m=j,G=G,gamma=gamma)
    }
  }
  
  #set starting parameter for pList
  p0 = stat_distr(gamma)
  for(l in 1:r){
    pList[[l]] = numeric(length(G[[l]]))
    sumGroup_l = sum(p0[G[[l]]])
    pList[[l]] = p0[G[[l]]]/sumGroup_l
  }
  
  return(list(nu=nu,pList=pList))
  
}

reduceTpm <-
function(transitionMatrix,G){
  
  gamma=transitionMatrix
  
  #number of sets in partition
  r = length(G)
  
  #number of states
  m=length(unlist(G))
  
  #set nu-matrix
  nu = mergeTpm(gamma,G)
  
  #set inner group probabilities
  pList = list()
  p0 = stat_distr(gamma)
  for(l in 1:r){
    pList[[l]] = numeric(length(G[[l]]))
    sumGroup_l = sum(p0[G[[l]]])
    pList[[l]] = p0[G[[l]]]/sumGroup_l
  }
  
  
  getGroupOfIndex = function(i,G){
    r=length(G)
    for(l in 1:r){
      if(any(G[[l]]==i)) return(l)  
    }
  }
  
  getPositionInGroup = function(i,G){  
    group = getGroupOfIndex(i,G)
    return(which(G[[group]]==i))  
  }
  
  #set gamma matrix back 
  gamma = NA * matrix(0,ncol=m,nrow=m)
  
  for(i in 1:m){
    for(j in 1:m){
      gamma[i,j] = nu[getGroupOfIndex(i,G),getGroupOfIndex(j,G)] * pList[[getGroupOfIndex(j,G)]][getPositionInGroup(j,G)]  
    }
  }
  
  return(gamma)
  
}

findIndependencePartition <-
function(m,x,alpha=0.05,estimateIn,details = FALSE,hmm=NULL,...){

  
  if(class(x)=="numeric"){
    distribution="normal"
    mDim = 1
  }
  
  if(class(x)=="matrix"){
    if(dim(x)[2]==1){
      distribution="normal"   
      mDim = 1
    }
    else{
      distribution="mv_normal" 
      mDim = dim(x)[2]
    }
  }
  
 
  #initial partition
  Gstart  = as.list(1:m)
  
  #check if unrestricted estimateIn is provided
  if(missing(estimateIn)){
    cat("Estimate model with", m,"states.\n")
    mleFullModel = mleHMM(x=x,m=m,G=Gstart,hmm=hmm,...)
    hmm0 = mleFullModel$mle
    stateParam0 = hmm0@stateParameters
    gamma0 = hmm0@transitionMatrix
  }
  else{
    mleFullModel = estimateIn
    hmm0 = estimateIn$mle
    stateParam0 = hmm0@stateParameters
    gamma0 = hmm0@transitionMatrix
  }
  
  
    
  #given a partition G this functions finds all partitions combined to of the sets
  getAllSmallerPartitions = function(G){
    
    #set length of partition
    r= length(G)
    
    #get all possible combinations
    com = subsets(r, 2, v = 1:r)
    N=dim(com)[1]
    
    Glist = list()
    for(i in 1:N){
      j0 = com[i,] # j0 is vector, these groups should be combined
      Gtmp = G
      Gtmp[[(j0[1])]] = c(G[[(j0[1])]],G[[(j0[2])]])
      Gtmp[[(j0[2])]] = NULL
      Glist[[i]] = Gtmp
    }
    return(Glist)
  }
  

  #list of partitions during iteration
  Gpath = list(); Gpath[[m]] = Gstart
  
     
  #track path of p-Values
  pValuePath = NA * numeric(m)
  
  #track path of loglikelihod ratio's
  likelihoodRatioPath = NA *numeric(m)
  
  #which one is the final model?
  finalModel = m
  
  #track all models during reducing steps
  modelPath = list()
  modelPath[[m]] = mleFullModel
  
  
  #track path of log-likelihoods
  mllkPath = NA * numeric(m) 
  mllkPath[m] = mleFullModel$mllk
  
  estimateRestrictedModels = TRUE
  
  #for each partition the mle is calculated under the restriction
  #gamma = \lambda_G(gamma)
  if(estimateRestrictedModels == TRUE){
    
    #set a function which calculates all mle's of a partition list
    tmpMle = function(i,Glist,data,hmm,...){
      #print(gamma)
      Ghere = Glist[[i]]
      return(try(mleHMM(x=data,m=m,G=Glist[[i]],hmm=hmm,...)))
    } 
    
    for(l in (m-1):1){
      

      
      #last step: fit iid model
      if(l==1){
        cat("Estimate model with", l,"state.\n")
        testChar = class(try(modelPath[[l]] <- mleHMM(x=x,m=m,G=list(1:m),hmm=hmm0,...)))
        if(testChar=="try-error"){
          cat("Error in last estimation step (i.i.d. model).")
          break
        }
        Gpath[[l]] = list(1:m) 
        mllkPath[l] = modelPath[[l]]$mllk
        likelihoodRatioPath[l] = 2*(modelPath[[l]]$mllk - modelPath[[m]]$mllk)
        rNow = length(Gpath[[l]])     
        pValuePath[l] = pchisq(q=likelihoodRatioPath[l],
                               df=m^2-2*m-rNow^2+2*rNow,lower.tail=FALSE)
        #check if H_0: lambda_Gpath[[1]](gamma) = gamma can be rejected
        if(pValuePath[l]<alpha){
          finalModel = l+1
        }
        else
          finalModel = l  
        }
      #previous m-2 steps
      else{
        cat("Estimate models with", l,"states.\n")
        
        #calculate for all one-level-lower-partitions the mles under the restriction
        GlistTmp = getAllSmallerPartitions(G=Gpath[[l+1]])

        Btmp = length(GlistTmp)
        
        cl <- makeCluster(detectCores())

        #ANPASSEN AUF PACKGE, dann hier library(mergeHMM)
        clusterEvalQ(cl, {
          ## set up each worker.  Could also use clusterExport()
#           library(sn)
#           library(mvtnorm)
#           library(RHmm)
#           library(parallel)
#           library(CombMSC)
#           source('D:/My Dropbox/R-Projekte/mergeHMM/mleHMM.R')
#           source('D:/My Dropbox/R-Projekte/mergeHMM/merging.R')
            library(mergeHMM)
          NULL
        })
        
          parallelOutput = parLapplyLB(cl = cl, X=1:Btmp,fun=tmpMle,data=x,Glist=GlistTmp,hmm=hmm0,...)

        
        stopCluster(cl)
        
        #parallelOutput = mclapply(X=1:Btmp,FUN=tmpMle,x=x,Glist=GlistTmp,hmm=hmm0,...)

        # paraOut0 <<- parallelOutput
        
        #find out which restriction yields highest likelihood
        mllkTmp = numeric(Btmp) + Inf

        for(i in 1:Btmp) try(mllkTmp[i] <- parallelOutput[[i]]$mllk)

        if(all(mllkTmp==Inf)){
          cat("All optimizations in this step failed.")
          break
        }
        
        jTmp = which.min(mllkTmp)

        #set partition which yields highest likelihood as new one
        Gpath[[l]] = GlistTmp[[jTmp]]
        
        modelPath[[l]] = parallelOutput[[jTmp]]
        
        mllkPath[l] = modelPath[[l]]$mllk

        likelihoodRatioPath[l] = 2*(modelPath[[l]]$mllk - modelPath[[m]]$mllk)
        
        rNow = length(Gpath[[l]])
        
        pValuePath[l] = pchisq(q=likelihoodRatioPath[l],
                               df=m^2-2*m-rNow^2+2*rNow,lower.tail=FALSE)
        

        #check if H_0: lambda_Gpath[[l]](gamma) = gamma can be rejected
        if(pValuePath[l]<alpha){
          finalModel = l+1
          break
        }
      }
    }
    if(details==FALSE){
      return(list(pValuePath = rev(pValuePath),
                  finalModel = modelPath[[finalModel]]$mle,
                  finalG=Gpath[[finalModel]]))
    }
    else{
      return(list(modelPath=rev(modelPath),
                  Gpath=rev(Gpath),
                  loglikePath=rev(-mllkPath),
                  likelihoodRatioPath=rev(likelihoodRatioPath),
                  pValuePath=rev(pValuePath),
                  finalModel = modelPath[[finalModel]]$mle,
                  finalG=Gpath[[finalModel]]))  
    }
  }
  
#   #for each partition the tpm is mapped with reduceTpm to a tpm
#   #fulfilling gamma = \lambda_G(gamma)
#   if(estimateRestrictedModels == FALSE){
#     
#     #use EM-Algo. fit-model as mle
#     fullModel = HMMFit(obs=x, dis="NORMAL", nStates=m, ...)
#     
#     
#     #track all models during reducing steps
#     modelPath = list()
#     modelPath[[m]] = fullModel
#     
#     
#     #track path of log-likelihoods
#     mllkPath = NA * numeric(m) 
#     mllkPath[m] = -fullModel$LLH
#     
#     
#     gamma0 = fullModel$HMM$transMat
#     
#     if(distribution=="normal"){
#       mu0 = fullModel$HMM$distribution$mean
#       sigma0 = sqrt(fullModel$HMM$distribution$var)
# 
#     } 
#     else{
#       mu0 = matrix(0,ncol=m,nrow=mDim)*NA
#       sigma0 = array(0,dim=c(mDim,mDim,m))*NA
#       for(i in 1:m){
#         mu0[,i] = fullModel$HMM$distribution$mean[[i]]
#         sigma0[,,i] = fullModel$HMM$distribution$cov[[i]]
#       }
#     }
#     
#     stateParam0 = list(mu=mu0,sigma=sigma0)
#     
#     
#     #set a function which calculates all mle's of a partition list
#     tmpReduceHmm = function(i,Glist,x,distribution){
#       modelTmp = list(stateParameters = stateParam0,gamma = NA,mllk=NA)
#       modelTmp$gamma = reduceTpm(gamma=gamma0,G=Glist[[i]])
#       modelTmp$mllk = HMMlogLike(stateParameters=stateParam0,gamma=modelTmp$gamma,
#                                  x=x,distribution=distribution,...)
#       return(modelTmp)
#     }
#     
# 
#     
#     for(l in (m-1):1){
#   
#       #last step: iid model
#       if(l==1){        
#         modelPath[[l]] = list(stateParameters = stateParam0,gamma = NA,mllk=NA)
#         modelPath[[l]]$gamma = reduceTpm(gamma=gamma0,G=list(1:m))
#         modelPath[[l]]$mllk = HMMlogLike(stateParameters=stateParam0,gamma=modelPath[[l]]$gamma,
#                                          x=x,distribution=distribution,...)
#         Gpath[[l]] = list(1:m) 
#         mllkPath[l] = modelPath[[l]]$mllk
#         
#         likelihoodRatioPath[l] = 2*(modelPath[[l]]$mllk - mllkPath[m])
#         rNow = length(Gpath[[l]])      
#         pValuePath[l] = pchisq(q=likelihoodRatioPath[l],
#                                df=m^2-2*m-rNow^2+2*rNow,lower.tail=FALSE)
#         
#         #check if H_0: lambda_Gpath[[1]](gamma) = gamma can be rejected
#         if(pValuePath[l]<alpha){
#           finalModel = l+1
#         }
#         else
#           finalModel = l        
#       }# end if l==1
#       else{
#         #calculate for all one-level-lower-partitions the mles under the restriction
#         GlistTmp = getAllSmallerPartitions(G=Gpath[[l+1]])
#         Btmp = length(GlistTmp)
#         parallelOutput = lapply(X=1:Btmp,tmpReduceHmm,x=x,distribution=distribution,
#                                   Glist=GlistTmp)
#         
#         #print(parallelOutput)
#         
#         #find out which restriction yields highest likelihood
#         mllkTmp = numeric(Btmp)
#         for(i in 1:Btmp) mllkTmp[i] = parallelOutput[[i]]$mllk
#         jTmp = which.min(mllkTmp)
#         
#         #set partition which yields highest likelihood as new one
#         Gpath[[l]] = GlistTmp[[jTmp]]
#         
#         modelPath[[l]] = parallelOutput[[jTmp]]
#         
#         mllkPath[l] = modelPath[[l]]$mllk
#         
#         likelihoodRatioPath[l] = 2*(modelPath[[l]]$mllk - mllkPath[m])
#         
#         rNow = length(Gpath[[l]])
#         
#         pValuePath[l] = pchisq(q=likelihoodRatioPath[l],
#                                df=m^2-2*m-rNow^2+2*rNow,lower.tail=FALSE)
# 
#         #check if H_0: lambda_Gpath[[l]](gamma) = gamma can be rejected
#         if(pValuePath[l]<alpha){
#           finalModel = l+1
#           break
#         }
#       }
#     }
#     if(details==FALSE){
#       return(list(finalModel = modelPath[[finalModel]],finalG=Gpath[[finalModel]]))
#     }
#     else{
#       return(list(modelPath=modelPath,Gpath=Gpath,loglikePath=-mllkPath,
#                   likelihoodRatioPath=likelihoodRatioPath,pValuePath=pValuePath,
#                   finalModel = modelPath[[finalModel]],finalG=Gpath[[finalModel]])) 
#     }
#         
#   }
  
}

simulateHMM <-
function(n,hmm){
  
  stateParameters = hmm@stateParameters
  if(hmm@internVariables$k!=hmm@internVariables$r){
    G = hmm@internVariables$G
    nuP = list(nu = hmm@transitionMatrix, pList = hmm@probList)  
    gamma = nuP2Gamma(nuPList=nuP,G=G)
    
  }
  else{
    gamma = hmm@transitionMatrix  
  }
  
  distribution = hmm@internVariables$distribution
  
  
  #no of states
  m=dim(gamma)[1]
  
  
  randomSample = function(n,parameter,distribution){
    if(distribution=="normal"){
      return(rnorm(n=n,mean=parameter[1],sd=parameter[2]))
    }
    
    if(distribution=="mv_normal"){
      return(rmnorm(n=n,mean=parameter$mu,varcov=parameter$sigma))
    }  
  }
  
  #reparametrisation
  stateParameters = extern2intern(stateParameters,distribution,m)
  
  #stationary distr.
  delta = stat_distr(gamma)
  
  #sample first state
  s = sample(x=1:m,size=1,replace=T,prob=delta)
  
  if(distribution == "normal")
    D=1
  if(distribution == "mv_normal")
    D = length(stateParameters[[1]]$mu)  
  
  
  #initialise data vector
  data=matrix(nrow=n,ncol=D)
  
  #sample first obs.
  data[1,] = randomSample(n=1,parameter=stateParameters[[s[1]]],distribution)
  
  #sample path
  for(i in 2:n){
    s[i] = sample(x=1:m,size=1,replace=T,prob=gamma[s[i-1],])
    data[i,] = randomSample(n=1,parameter=stateParameters[[s[i]]],distribution)
  }
  
  if(distribution == "normal")
    data = as.vector(data)
  
  return(list(data = data,s=s))
  
}

localDecodingEntopie <-
function(x,hmm,G,details=FALSE){
  
  
  stateParameters = hmm@stateParameters
  gamma = hmm@transitionMatrix
  distribution = hmm@internVariables$distribution
  
  m=dim(gamma)[1]
  
  if(length(hmm@internVariables$G)!=hmm@internVariables$k)
    return("Only non-mixture models supported. Dirctly use unmerged and requested one.")
  
  if(length(G)==1)
    return(list(entropy=0))
  
  #print("hier")
  
  #transform to intern parametrization, each list entry is a stet dep. parameter
  stateParameters = extern2intern(stateParameters,distribution,m)
  
  #mixtures for merged states
  dmixture = function(x,pList,G,stateParameters,l,distribution){
    
    states = G[[l]]
    probs = pList[[l]]
    
    np = length(probs)
    
    if(distribution=="poisson"){
      #density
      f0 = function(x,par){lambda=par;return(dpois(x,lambda=lambda))} 
    }
    
    if(distribution=="normal"){
      #density
      f0 = function(x,par){
        mu    = par[1]
        sigma = par[2]
        return(dnorm(x,mean=mu,sd=sigma))
      }
    }
    
    if(distribution=="mv_normal"){
      #density
      f0 = function(x,par){
        mu    = par$mu
        sigma = par$sigma
        return(dmnorm(x=x,mean=mu,varcov=sigma))
      }
    }
    
    erg=0
    for(i in 1:np){
      erg = erg + probs[i] * f0(x,stateParameters[[(states[i])]])
    }
    
    return(erg)
    
  }
  
  #calculates the state dep. mixture values given kxk tpm and partition G
  calculateStatedepDens  = function(x, stateParameters, gamma, G, distribution){
    
    nuP = gamma2nuP(gamma,G)
    nu = nuP$nu
    pList = nuP$pList
    
    #no. of states after merge, i.e. sets in G
    nNu = dim(nu)[1]
    
    
    #allprobs = matrix(NA,ncol=m,nrow=n)
    allprobs = dmixture(x,pList,G,stateParameters,l=1,distribution)
    
    if(m==1) return(allprobs)
    for(j in 2:nNu) allprobs = cbind(allprobs,dmixture(x,pList,G,stateParameters,l=j,distribution))
    
    return(allprobs)
  }
  
  #adapted help-function of Zucchini to calculate conditional probabilities
  HMM.lalphabeta = function(x,stateParameters, gamma, G,distribution){
    
    nuP = gamma2nuP(gamma,G)
    
    nu=nuP$nu
    pList = nuP$pList
    
    nNu = dim(nu)[1]
    delta<-solve(t(diag(nNu)-nu+1),rep(1,nNu))
    
    #no. of observations
    n = ifelse(test=is.matrix(x),yes=n<-dim(x)[1],no=n<-length(x))
    
    lalpha     <- lbeta<-matrix(NA,nNu,n)
    allprobs   <- calculateStatedepDens(x, stateParameters, gamma, G,distribution)
    foo        <- delta*allprobs[1,]
    sumfoo     <- sum(foo)
    lscale     <- log(sumfoo)
    foo        <- foo/sumfoo
    lalpha[,1] <- log(foo)+lscale
    for (i in 2:n)
    {
      foo        <- foo%*%nu*allprobs[i,]
      sumfoo     <- sum(foo)
      lscale     <- lscale+log(sumfoo)
      foo        <- foo/sumfoo
      lalpha[,i] <- log(foo)+lscale
    }
    lbeta[,n]  <- rep(0,nNu)
    foo        <- rep(1/nNu,nNu)
    lscale     <- log(nNu)
    for (i in (n-1):1)
    {
      foo        <- nu%*%(allprobs[i+1,]*foo)
      lbeta[,i]  <- log(foo)+lscale
      sumfoo     <- sum(foo)
      foo        <- foo/sumfoo
      lscale     <- lscale+log(sumfoo)
    }
    list(la=lalpha,lb=lbeta)
  }
  
  #function no. 2, finally calculates cond. probs
  HMM.state_probs = function(x,stateParameters, gamma, G,distribution){
    m=length(G)
    #delta<-solve(t(diag(m)-gamma+1),rep(1,m))
    
    #no. of observations
    n = ifelse(test=is.matrix(x),yes=n<-dim(x)[1],no=n<-length(x))
    
    fb         <- HMM.lalphabeta(x,stateParameters, gamma, G,distribution)
    la         <- fb$la
    lb         <- fb$lb
    cc          <- max(la[,n])
    llk        <- cc+log(sum(exp(la[,n]-cc)))
    stateprobs <- matrix(NA,ncol=n,nrow=m)
    for (i in 1:n) stateprobs[,i]<-exp(la[,i]+lb[,i]-llk)
    stateprobs
  }
  
  #use the defined functions
  probs = HMM.state_probs(x,stateParameters, gamma, G,distribution)
  
  probsVec = as.vector(probs)
  
  probsVec=probsVec[probsVec!=0]
  
  if(details==TRUE)
    list(entropy = - sum(log(probsVec) * probsVec),probs=probs)  
  else
    list(entropy = - sum(log(probsVec) * probsVec))
  
}

viterbiHMM <-
function(x, hmm) {                                                           
  
  G = hmm@internVariables$G
  stateParameters = hmm@stateParameters

  nuPList = list(nu = hmm@transitionMatrix, pList = hmm@probList)
  
  gamma = nuP2Gamma(nuPList,G=hmm@internVariables$G)

  distribution = hmm@internVariables$distribution
  

  
  m=dim(gamma)[1]
  
  #reparametrisation
  stateParameters = extern2intern(stateParameters,distribution,m)
  
  #if(missing(G)) G = as.list(1:m)
  
  #no. of observations
  n = ifelse(test=is.matrix(x),yes=n<-dim(x)[1],no=n<-length(x))
  
  #old way -> no mixtures as state dep. distr. possible
  #allprobs <- matrix(NA,ncol=m,nrow=n)
  #for(i in 1:m) allprobs[,i] = f0(x,stateParameters[[i]])
  
  
  #mixtures for merged states
  dmixture = function(x,pList,G,stateParameters,l,distribution){
    
    states = G[[l]]
    probs = pList[[l]]
    
    np = length(probs)
    
    if(distribution=="poisson"){
      #density
      f0 = function(x,par){lambda=par;return(dpois(x,lambda=lambda))} 
    }
    
    if(distribution=="normal"){
      #density
      f0 = function(x,par){
        mu    = par[1]
        sigma = par[2]
        return(dnorm(x,mean=mu,sd=sigma))
      }
    }
    
    if(distribution=="mv_normal"){
      #density
      f0 = function(x,par){
        mu    = par$mu
        sigma = par$sigma
        return(dmnorm(x=x,mean=mu,varcov=sigma))
      }
    }
    
    erg=0
    for(i in 1:np){
      erg = erg + probs[i] * f0(x,stateParameters[[(states[i])]])
    }
    
    return(erg)
    
  }
  
  #calculates the state dep. mixture values given kxk tpm and partition G
  calculateStatedepDens  = function(x, stateParameters, gamma, G, distribution){
    
    nuP = gamma2nuP(gamma,G)
    nu = nuP$nu
    pList = nuP$pList
    
    #no. of states after merge, i.e. sets in G
    nNu = dim(nu)[1]
    
    
    #allprobs = matrix(NA,ncol=m,nrow=n)
    allprobs = dmixture(x,pList,G,stateParameters,l=1,distribution)
    
    if(m==1) return(allprobs)
    for(j in 2:nNu) allprobs = cbind(allprobs,dmixture(x,pList,G,stateParameters,l=j,distribution))
    
    return(allprobs)
  }
  
  #calculate state dep. density values
  allprobs = calculateStatedepDens(x, stateParameters, gamma, G, distribution)
  
  
  #tpm of merged model is nu
  nuP = gamma2nuP(gamma,G)
  nu = nuP$nu; m2 = dim(nu)[1]
  pList = nuP$pList
  
  delta<-solve(t(diag(m2)-nu+1),rep(1,m2))
  
  xi        <- matrix(0,n,m2)                                
  foo       <- delta*allprobs[1,]                          
  xi[1,]    <- foo/sum(foo)                                 
  for (i in 2:n)                                             
  {                                                        
    foo    <- apply(xi[i-1,]*nu,2,max)*allprobs[i,]      
    xi[i,] <- foo/sum(foo)                                   
  }                                                        
  iv<-numeric(n)                                             
  iv[n]     <-which.max(xi[n,])                             
  for (i in (n-1):1)                                         
    iv[i] <- which.max(nu[,iv[i+1]]*xi[i,])               
  iv                                                         
}

mleHMM <-
function(x,m,G=as.list(1:m),hmm=NULL,...){
  
#   #number of states
#   m = length(unlist(G))
  
  if(!is.null(hmm)){
    stateParameters = hmm@stateParameters
    gamma = hmm@transitionMatrix
    
    distribution = hmm@internVariables$distribution
  }
  else{
    
    #univariate?
    if(class(x)=="numeric"){
      distribution="normal"  
    }
    #multivariate?
    if(class(x)=="matrix"){
      if(dim(x)[2]==1)
        distribution="normal"    
      else
        distribution="mv_normal"  
    }  
    
    
  }


  if(distribution=="normal"){
    
    #if one of the stating parameters is missing calculate values with RHmm  
    if(is.null(hmm)){
      cat("No Starting Parameter supplied.\n")
      cat("Use EM-algorithm of package RHmm to estimate HMM...")
      emFit = HMMFit(obs=x,nStates=m,...)
      muIn = emFit$HMM$distribution$mean
      sigmaIn = sqrt(emFit$HMM$distribution$var)
      stateParameters = list(mu = muIn, sigma = sigmaIn)
      gamma = emFit$HMM$transMat
    }
          
    #transformation for state dep. parameters
    n2w = function(x){c(x[1],log(x[2]))}
    w2n = function(x){c(x[1],exp(x[2]))}    
    
    #density
    f0 = function(x,par){
      mu    = par[1]
      sigma = par[2]
      return(dnorm(x,mean=mu,sd=sigma))
    }

    #state dep. parameter as list
    startP = extern2intern(parameter=stateParameters,distribution=distribution,m=m)
    
    
    cat(" done. \n")
    cat("Use nlm to improve fit...")
    
    ergMLE = mleHMMintern(x=x,m=m,G=G,f=f0,pn2pw=n2w,pw2pn=w2n,
                        startParameters=startP,startGamma=gamma,...)
    cat(" done. \n")
    
  }
  
  if(distribution=="mv_normal"){
    
    #if one of the stating parameters is missing calculate values with RHmm  
    if(is.null(hmm)){
      cat("No Starting Parameter supplied.\n")
      cat("Use EM-algorithm of package RHmm to estimate HMM...")
      
      emFit = HMMFit(obs=x,nStates=m,...)
      
      sigmaIn = array(dim=c(dim(x)[2],dim(x)[2],m))
      muIn = matrix(nrow=dim(x)[2],ncol=m)
      for(i in 1:m){
        sigmaIn[,,i] = emFit$HMM$distribution$cov[[i]]
        muIn[,i] = emFit$HMM$distribution$mean[[i]]
      }
      stateParameters = list(mu = muIn, sigma = sigmaIn)
      gamma = emFit$HMM$transMat
    
      cat(" done. \n")
      cat("Use nlm to improve fit...\n")
    }

  
    #get dimension of dataset -> needed for transformation w2n()
    D = dim(x)[2]
    
    #par is list with entries mu (vector) an sigma (matrix)
    n2w = function(par){
      #print(par)   
      #get parameters out of list
      mu = par$mu
      sigma = par$sigma
      
      #cholesky decomposition
      sigmaChol = t(chol(sigma))
      
      #write parameter to vector
      para = diag(sigmaChol)
      for(d in 1:(D-1)){
        para = c(para,sigmaChol[(d+1):D,d])
      }
      
      para = c(para,mu)
      return(para)
      
    }
    
    w2n = function(par){
      
      sigmaTMP = diag(par[1:D])  
      par = par[-(1:D)]
      for(d in 1:(D-1)){
        sigmaTMP[(d+1):D,d] = par[1:(D-d)]
        par = par[-c(1:(D-d))]
      }
      
      sigma = sigmaTMP %*% t(sigmaTMP)
      
      return(list(mu=tail(x=par,n=D),sigma=sigma))
      
    }

    #density
    f0 = function(x,par){
      mu    = par$mu
      sigma = par$sigma
      return(dmnorm(x=x,mean=mu,varcov=sigma))
    }
    
    
    #state dep. parameter as a list
    startP = extern2intern(parameter=stateParameters,distribution=distribution,m=m)
    

    
    ergMLE = mleHMMintern(x=x,m=m,G=G,f=f0,pn2pw=n2w,pw2pn=w2n,
                        startParameters=startP,startGamma=gamma,...)
    
  }
  
  #transform state dep. to nicer output
  ergMLE$mle$stateDepParameters = intern2extern(ergMLE$mle$stateDepParameters,distribution,m)

  par_est = setHMM(transitionMatrix=ergMLE$mle$gamma,mu=ergMLE$mle$stateDepParameters$mu,sigma=ergMLE$mle$stateDepParameters$sigma)
  
  ergMLE$mle = par_est
  
  return(ergMLE)
}

intern2extern <-
function(parameter,distribution,m){
  
  if(distribution=="poisson"){
    return(unlist(parameter))  
  }
  
  if(distribution=="normal"){
    startP = list(mu=numeric(m),sigma=numeric(m))
    for(i in 1:m){
      startP$mu[i] = (parameter[[i]])[1]
      startP$sigma[i] = (parameter[[i]])[2]    
      }
    return(startP)  
  }
  
  if(distribution=="mv_normal"){
    D = length(parameter[[1]]$mu)
    startP = list()
    mu = NA*matrix(0,ncol=m,nrow=D)
    sigma = NA*array(0,dim=c(D,D,m))
    for(i in 1:m){
      mu[,i] = parameter[[i]]$mu
      sigma[,,i] = parameter[[i]]$sigma
    }
    return(list(mu=mu,sigma=sigma))
  }
  
}

getNextPartitions <-
function(G,independenceClusters){
  
  if(length(G)==1) return(G)
  
  #test if A subset B
  isSubset = function(A,B){
    
    lengthA = length(A)
    checkAll = logical(lengthA)
    
    #check if A[i] \in B
    for(i in 1:lengthA)
      checkAll[i] = any(A[i]==B)
    
    #check if all A[i] in B
    return(all(checkAll))
  }
  
  #checks if each set of G is a subset of any set in independenceClusters
  isValidPartition = function(G,independenceClusters){
    
    #have to have same length
    if(length(unlist(independenceClusters)) != length(unlist(G)))
      return(FALSE)
    
    #same elements in partitions ? 
    if( any(sort(unlist(independenceClusters))!=sort(unlist(G))) )
      return(FALSE)
    
    rG = length(G)
    r  = length(independenceClusters)  
    
    #checkvector of is set is subset of any set in indClust.
    checkVector = logical(rG)
    
    for(i in 1:rG){
      checkvectorTMP = logical(r) 
      for(j in 1:r){
        checkvectorTMP[j] = isSubset(A=G[[i]],B=independenceClusters[[j]]) 
      }
      checkVector[i] = any(checkvectorTMP)
    }
    
    return(all(checkVector))
  }
  
  #given a partition G this functions finds all partitions combined two of the sets
  getAllSmallerPartitions = function(G){
    
    #set length of partition
    r= length(G)
    
    #get all possible combinations
    com = subsets(r, 2, v = 1:r)
    N=dim(com)[1]
    
    Glist = list()
    for(i in 1:N){
      j0 = com[i,] # j0 is vector, these groups should be combined
      Gtmp = G
      Gtmp[[(j0[1])]] = c(G[[(j0[1])]],G[[(j0[2])]])
      Gtmp[[(j0[2])]] = NULL
      Glist[[i]] = Gtmp
    }
    return(Glist)
  }
  
  #calculate all possible next partitions
  candidatePartitions = getAllSmallerPartitions(G)
  rCand = length(candidatePartitions)
  
  #only valid partitions should be kept...
  #initialize vecor
  keepThese = rep(FALSE,rCand)
  
  #check if a possible partition is valid
  for(i in 1:rCand){
    if(isValidPartition(G=candidatePartitions[[i]],independenceClusters))
      keepThese[i]=TRUE 
  }
  
  return(candidatePartitions[keepThese])
  
}

stat_distr <-
function(mat){
  m0=dim(mat)[1]
  I_m = diag(rep(1,m0))
  U = matrix(rep(1,m0*m0),nrow=m0)
  M = I_m - mat + U
  One = matrix(rep(1,m0),nrow=1)
  erg = One %*% solve(M)
  return(as.vector(erg))
}

reduceHMM <-
function(hmm,G){
  
#   reOrder = unlist(G)
# 
#   setHMM(transitionMatrix=reduceTpm(hmm@transitionMatrix,G)[reOrder,reOrder],
#          mu=hmm@stateParameters$mu[,reOrder],
#          sigma=hmm@stateParameters$sigma[,,reOrder])
  

  setHMM(transitionMatrix=reduceTpm(hmm@transitionMatrix,G),
         mu=hmm@stateParameters$mu,
         sigma=hmm@stateParameters$sigma)
  
}

\name{mergeHMM-package}
\alias{mergeHMM-package}
%\alias{mergeHMM}
\docType{package}
\title{
Investigate the dependence structure of an hidden Markov model
}
\description{
In Holzmann and Schwaiger (2013) we consider hidden Markov models with state-dependent finite mixtures, here implemented for the univariate and multivariate normal distribution. 

This packages provides functions to find an appropriate model by backward selection based on the proposed test (see \code{\link[mergeHMM]{findIndependencePartition}}). A function to calculate local decoding entropies iteratively, as defined in the paper, is also included (see \code{\link[mergeHMM]{investigateMergedHMMs}}). This function can be used to find state-dependent distributions which form a density based cluster. Further, functions to simulate datasets, to estimate models via MLE under dependence-structure restrictions or to perform a maximum-a-posteriori analysis with the Viterbi algorithm are included. Finally, to merge states of a given (estimated) HMM we provide the function \code{\link[mergeHMM]{mergeHMM}}, whereas further explanations of the here considered model class are given in the help file of \code{\link[mergeHMM]{mergeHMM}}.
}
\details{
\tabular{ll}{
Package: \tab mergeHMM\cr
Type: \tab Package\cr
Version: \tab 1.0\cr
Date: \tab 2013-05-06\cr
License: \tab GPL-2\cr
}

}
\author{
Florian Schwaiger <schwaige@mathematik.uni-marburg.de>
}
\references{
Holzmann, H. and Schwaiger, F. (2013). Hidden Markov models with state-dependent mixtures: Minimal representation, model testing and applications to clustering.

Zucchini and MacDonald (2009). Hidden Markov Models for Time Series: An Introduction Using R.
}

\keyword{ merging }
\keyword{ hidden Markov model }
\keyword{ hmm }
\seealso{
\code{\link[mergeHMM]{findIndependencePartition}}, \code{\link[mergeHMM]{investigateMergedHMMs}}, \code{\link[mergeHMM]{simulateHMM}}, \code{\link[mergeHMM]{mleHMM}}, \code{\link[mergeHMM]{viterbiHMM}} and \code{\link[mergeHMM]{mergeHMM}}
}
\examples{
#setting an HMM which has independence partition {{1,2},{3}}
r1 = c(0.8 * c(0.5,0.5), 0.2)
r3 = c(0.1 * c(0.5,0.5), 0.9)
tpm0 = rbind(r1,r1,r3)
mu0 = c(1,3,7)
sigma0 = rep(0.8,3)
hmm0= setHMM(transitionMatrix=tpm0,mu=mu0,sigma=sigma0)

#simulating a dataset
set.seed(1)
x = simulateHMM(n=500, hmm=hmm0)$data

#estimate unrestricted HMM
mle0 = mleHMM(x=x,m=3); mle0
#applying Viterbi algorithm
viterbiHMM(x=x,hmm=mle0$mle)

#merging states 
mergedModel1 = mergeHMM(hmm=hmm0,G=list(1:2,3)); mergedModel1
mergedModel2 = mergeHMM(hmm=mle0$mle,G=list(1:2,3)); mergedModel2

#for examples of the main algorithms see the help files of
#findIndependencePartition and investigateMergedHMMs
}
\keyword{ merge }
\keyword{ hmm   }
\keyword{ hidden  }
\keyword{ markov }
\keyword{ model }

\name{setHMM}
\alias{setHMM}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Setting a hidden Markov model.
}
\description{
This function should be used in order to set an object of type \code{\link[mergeHMM]{hmmClass-class}}. Models with (mixtures of) normal or multivariate normal state-dependent distributions are implemented. For the exact parametrization see the details section.

The functions \code{\link[mergeHMM]{mleHMM}} and \code{\link[mergeHMM]{findIndependencePartition}} estimate HMMs and use the class \code{\link[mergeHMM]{hmmClass-class}} as output.
}
\usage{
setHMM(transitionMatrix, mu, sigma, probList = as.list(rep(x = 1, times = dim(transitionMatrix)[1])))
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{transitionMatrix}{
a square matrix, which is a transition matrix
}
  \item{mu}{
the mean parameters, vector or matrix, see details
}
  \item{sigma}{
the scale parameters, vector or array, see details
}
  \item{probList}{
the probabilities of state-dependent finite mixtures, see details
}
}
\details{
The parametrization is as follows: We consider the situation where the number of all mixture states equals k. Thus there are k mean parameters and k variance parameters. In the univariate case we thus have two vectors of dimension k. In the multivariate case (with dimension = d) each mean parameter has d entries, thus we parametrize the hole mean parameter of the HMM by a (d x k) matrix, i.e. the dimensions are row-wise.  For the variance parameter there is for each state one (d x d) matrix, therefore  the variance parameter of the whole model is parametrized by an array of dimension (d x d x k).  

In order to allow for mixtures there is the argument \code{probList}. As default it is a list with k entries where each entry equals one. This parametrizes a common HMM with k states and normal state dependent distributions. 

If e.g. the first state dependent distribution should be a mixture with k1 components then the first list element of \code{probList} has to be a k1-dimensional probability vector (positive and summing up to one). Further the first k1 elements in the mean and variance parameter correspond to this mixture. For the second and further states one proceeds accordingly.

Note, that the number of list entries of \code{probList} (e.g. r) has to be suitable to the given selected transition probability matrix, i.e. the dimension has to be (r x r). In case of some distribution are mixtures and some are just normals all list entries in \code{probList} have to be entered (although some are one). In case of no mixtures r simply equals k. 
}
\value{
an object of type \code{\link[mergeHMM]{hmmClass-class}}.
}

\examples{

#example 1: setting a usual (univariate) normal HMM
tpm1 = matrix(c(0.92,0.02,0.02,0.02,0.02,
                0.02,0.92,0.02,0.02,0.02,
                0.02,0.02,0.92,0.02,0.02,
                0.02,0.02,0.02,0.92,0.02,
                0.02,0.02,0.02,0.02,0.92),ncol=5,nrow=5,byrow=TRUE)
mu1 = c(1,3,6,10,15)
sigma1 = rep(1,5)
hmm1 = setHMM(transitionMatrix=tpm1,mu=mu1,sigma=sigma1); hmm1

#example 2: setting a two state HMM with state-dependent mixtures of (univariate) normals
tpm2 = matrix(c(0.9,0.1,
			   0.1,0.9),ncol=2,nrow=2,byrow=TRUE)
hmm2 = setHMM(transitionMatrix=tpm2,mu=mu1,sigma=sigma1,probList=list(c(1/3,1/3,1/3),c(0.75,0.25))); hmm2

#example3: setting a two state HMM with state-dependent mixtures of (bivariate) normals

sigma0 = array(dim=c(2,2,5))
sigma0[,,1] = matrix(0.3*c(1,0.6,0.6,1),byrow=TRUE,ncol=2)
sigma0[,,2] = matrix(0.3*c(1,-0.6,-0.6,1),byrow=TRUE,ncol=2)
sigma0[,,3] = matrix(1.2*c(0.4,-0.35,-0.35,0.4),byrow=TRUE,ncol=2)
sigma0[,,4] = matrix(0.3*c(4,0.9,0.9,4),byrow=TRUE,ncol=2)
sigma0[,,5] = matrix(0.5*c(1,0.8,0.8,1) ,byrow=TRUE,ncol=2)


mu0 = NA * matrix(0,ncol=5,nrow=2)
mu0[,1] = c(2.5,1.5)
mu0[,2] = c(3.5,2)
mu0[,3] = c(2,7)
mu0[,4] = c(3,0.5)
mu0[,5] = c(2.5,6)

hmm3 = setHMM(transitionMatrix=tpm2,mu=mu0,sigma=sigma0,probList=list(c(0.2,0.5,0.15,0.15),1)); hmm3

}

\name{simulateHMM}
\alias{simulateHMM}

\title{
Simulate a dataset.
}
\description{
This function simulates a dataset of a given HMM. 
}
\usage{
simulateHMM(n, hmm)
}

\arguments{
  \item{n}{
the sample size
}
  \item{hmm}{
the HMM, i.e. an object of type \code{\link[mergeHMM]{hmmClass-class}}
}
}
\examples{
#setting an HMM which has independence partition {{1,2},{3}}
r1 = c(0.8 * c(0.5,0.5), 0.2)
r3 = c(0.1 * c(0.5,0.5), 0.9)
tpm0 = rbind(r1,r1,r3)
mu0 = c(1,3,7)
sigma0 = rep(0.8,3)
hmm0= setHMM(transitionMatrix=tpm0,mu=mu0,sigma=sigma0)

#simulating a dataset
set.seed(1)
x = simulateHMM(n=500, hmm=hmm0)$data
plot(density(x))
}
\keyword{ simulation }
\keyword{ hidden   }
\keyword{ Markov  }
\keyword{ model }

\name{reduceTpm}
\alias{reduceTpm}
\title{
Reducing dependence information of a Markov chain.
}
\description{
This is the same transformation as in \code{\link[mergeHMM]{reduceHMM}} for the hidden Markov chain, but here the input/output is only a transition probability matrix. 
}
\usage{
reduceTpm(transitionMatrix, G)
}
\arguments{
  \item{transitionMatrix}{
a transition probability matrix of dimension (k x k).
}
  \item{G}{
a list, which is a partition of the state space 1,...,k (each list entry is thus a vector), see the example below.
}
}
\value{
a transition probability matrix of dimension (k x k).
}
\seealso{
\code{\link[mergeHMM]{reduceHMM}}
}
\examples{
#first example
tpm1 = matrix(c(0.92,0.02,0.02,0.02,0.02,
                0.02,0.92,0.02,0.02,0.02,
                0.02,0.02,0.92,0.02,0.02,
                0.02,0.02,0.02,0.92,0.02,
                0.02,0.02,0.02,0.02,0.92),ncol=5,nrow=5,byrow=TRUE)
G_in = list(1:2,3:4,5)
reduceTpm(transitionMatrix=tpm1,G=G_in)

#second example
r12 = c( 0.7 * c(0.9,0.1), 0.2  * c(0.2,0.8), 0.1  )
r34 = c( 0.1 * c(0.9,0.1), 0.8  * c(0.2,0.8), 0.1  )
r5   = c( 0.1 * c(0.9,0.1), 0.05 * c(0.2,0.8), 0.85  )
tpm2 = rbind(r12,r12,r34,r34,r5)
reduceTpm(transitionMatrix=tpm2,G=G_in)
}
\keyword{ reducing }

\name{show-methods}
\docType{methods}
\alias{show-methods}
\alias{show}
\alias{show,ANY-method}
\alias{show,hmmClass-method}
\alias{show,hmmClassNormal-method}
\alias{show,hmmClassMvNormal-method}
\title{ Output of HMMs on console.}
\description{
Provides for each HMM an output on the console.
}

\name{localDecodingEntopie}
\alias{localDecodingEntopie}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Calculate Local decoding entropies.
}
\description{
The local decoding entropy (LDE) is the sum of the entropies of the a-posteriori probabilities for the hidden Markov chain to attain at time t state j (j=1,..,k) given the whole observable process, see Holzmann an Schwaiger (2013). This function calculates the LDE of an HMM when merging the states w.r.t. partition G. The input has to be an usual HMM (non-mixture state-dependent distributions) and the partition G which gives the states to be merged. The reason for this parametrization is, that so we can easily compare LDE-values when merging w.r.t. different partitions. We adapted the functions of Zucchini (2009) for calculating local decoding probabilities to the setting with potentially mixtures as state dependent distributions.
}
\usage{
localDecodingEntopie(x, hmm, G, details = FALSE)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{
dataset
}
  \item{hmm}{
an object of type \code{\link[mergeHMM]{hmmClass-class}}, no state-dependent mixtures, use G for that.
}
  \item{G}{
a list, which is a partition of the state space 1,...,k (each list entry is thus a vector), see the example below.
}
  \item{details}{
if TRUE, also the a-posteriori probabilities are returned
}
}
\value{
a list with entries depending on variable details

\item{entropy}{the local decoding entropy}
\item{probs}{the local decoding a-posteriori probabilities}

}
\references{
Holzmann, H. and Schwaiger, F. (2013). Hidden Markov models with state-dependent mixtures: Minimal representation, model testing and applications to clustering.

Zucchini and MacDonald (2009). Hidden Markov Models for Time Series: An Introduction Using R.
}


\examples{

#setting an HMM which has independence partition {{1,2},{3}}
r1 = c(0.8 * c(0.5,0.5), 0.2)
r3 = c(0.1 * c(0.5,0.5), 0.9)
tpm0 = rbind(r1,r1,r3)
mu0 = c(1,3,7)
sigma0 = rep(0.8,3)
hmm0= setHMM(transitionMatrix=tpm0,mu=mu0,sigma=sigma0)

set.seed(1)
x = simulateHMM(n=500, hmm=hmm0)$data

#LDE of HMM under under different restrictions
localDecodingEntopie(x=x,hmm=hmm0,G=as.list(1:3))
localDecodingEntopie(x=x,hmm=hmm0,G=list(1:2,3))
localDecodingEntopie(x=x,hmm=hmm0,G=list(1:3))
}
\keyword{ LDE }
\keyword{ local   }
\keyword{ decoding  }
\keyword{ entropy }
\keyword{ cluster }

\name{reduceHMM}
\alias{reduceHMM}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Reducing a hidden Markov model.
}
\description{
The function \code{reduceHMM} reduces the dependence structure of the hidden Markov chain of an HMM given a partition of the state space 1,...,k, i.e. an HMM is mapped onto a new HMM. Note that the given partition should divide the state space into r<k groups. The new transition probability from state i to j results by splitting the original state migration into two steps: It is the product of the probability from switching from the group where i is in to the group where j is in AND the probability for state j given the Markov chain is in the group where j is in. The function is detailedly defined in Holzmann and Schwaiger (2013).

The distribution of the observable part (as hole process) of the reduced HMM is the same as for the merged HMM, see \code{\link[mergeHMM]{mergeHMM}}. In general both models differ from the original one. 
}
\usage{
reduceHMM(hmm, G)
}
\arguments{
  \item{hmm}{
an object of type \code{\link[mergeHMM]{hmmClass-class}}. For creating such an object use \code{\link[mergeHMM]{setHMM}}.
}
  \item{G}{
a list, which is a partition of the state space 1,...,k (each list entry is thus a vector), see the example below.
}
}
\value{
an object of type \code{\link[mergeHMM]{hmmClass-class}}.
}
\references{
Holzmann, H. and Schwaiger, F. (2013). Hidden Markov models with state-dependent mixtures: Minimal representation, model testing and applications to clustering.
}

\seealso{
\code{\link[mergeHMM]{mergeHMM}}
}
\examples{
#first example:
#  setting a five state HMM with strongly persistent structure in the hidden Markov chain
#  the dependence structure will change under merging or reducing

#settinng the input HMM (five states)
tpm1 = matrix(c(0.92,0.02,0.02,0.02,0.02,
                0.02,0.92,0.02,0.02,0.02,
                0.02,0.02,0.92,0.02,0.02,
                0.02,0.02,0.02,0.92,0.02,
                0.02,0.02,0.02,0.02,0.92),ncol=5,nrow=5,byrow=TRUE)
mu0 = c(1,3,6,10,15)
sigma0 = rep(1,5)
hmmIn = setHMM(transitionMatrix=tpm1,mu=mu0,sigma=sigma0)

#setting a partition 
# -> sets states 1 and 2, 3 and 4 and 5 each to one group  
G_in = list(1:2,3:4,5)

mergeHMM(hmm=hmmIn,G=G_in)
reduceHMM(hmm=hmmIn,G=G_in) # tpm does change in comparison to tpm1!

#second example:
#  setting a five state HMM with potential for merging
#  the dependence structure of the model will not change under merging or reducing
r12 = c( 0.7 * c(0.9,0.1), 0.2  * c(0.2,0.8), 0.1  )
r34 = c( 0.1 * c(0.9,0.1), 0.8  * c(0.2,0.8), 0.1  )
r5   = c( 0.1 * c(0.9,0.1), 0.05 * c(0.2,0.8), 0.85  )

tpm2 = rbind(r12,r12,r34,r34,r5)
hmmIn2 = setHMM(transitionMatrix=tpm2,mu=mu0,sigma=sigma0)


mergeHMM(hmm=hmmIn2,G=G_in)
reduceHMM(hmm=hmmIn2,G=G_in) # tpm does NOT change in comparison to tpm2!
}
\keyword{ merging }
\keyword{ reducing }

\name{hmmClass-class}
\docType{class}
\alias{hmmClass-class}
\alias{hmmClassNormal-class}
\alias{hmmClassMvNormal-class}
\title{Class for hiddenMarkovModels.}
\description{Hidden Markov model class.}
\section{Objects from the Class}{
Objects should be set with the function \code{\link[mergeHMM]{setHMM}}.
}
\section{Slots}{
Each model has the following five slots. 
\describe{
  \item{\code{distribution}:}{a character, specifies the state-dependent distribution.}  
  \item{\code{transitionMatrix}:}{a square matrix, represents the transition probability matrix}
   \item{\code{stateParameters}:}{a list, specifies the state-dependent parameters of the HMM}   
   \item{\code{probList}:}{a list, specifies the weights of the state-dependent finite mixtures.}  
\item{\code{internVariables}:}{a list, contains several intern variables.}  
}
}
\section{Methods}{
For each model the following generic functions are provided: 
\describe{
     \item{investigateMergedHMMs:}{ find density based cluster }    
     \item{mergeHMM:}{ merge states of the HMM }
     \item{reduceHMM:}{ reduce dependence information of the HMM }
     \item{simulateHMM:}{ simulate a dataset }
     \item{viterbiHMM:}{ apply Viterbi algorithm for maximum a-posteriori estimation }
  }
}
\section{Extends}{
  The classes
  \describe{
    \item{\code{hmmClassNormal}}{}
    \item{\code{hmmClassMvNormal}}{}
  }
  extend the class \code{hmmClass}.
}

\seealso{
\code{\link[mergeHMM]{setHMM}}
}

\keyword{hidden}
\keyword{Markov}
\keyword{model}

\name{viterbiHMM}
\alias{viterbiHMM}
\title{
Viterbi algorithm for normal-mixture HMMs.
}
\description{
Given a dataset and an object of type \code{\link[mergeHMM]{hmmClass-class}} this function calculates the most likely sequence of states. The state dependent distributions can be mixtures of normal or just normal distributions.
}
\usage{
viterbiHMM(x, hmm)
}
\arguments{
  \item{x}{
a dataset. For the univariate case a vector for the multivariate case a matrix, where the dimensions have to be row-wise.
}
  \item{hmm}{
an object of type \code{\link[mergeHMM]{hmmClass-class}}. For creating such an object use \code{\link[mergeHMM]{setHMM}}.
}
}
\details{
The code in Zucchini and MacDonald (2009) was adopted by us to the setting with potentially mixtures as state dependent distributions.
}
\value{
a vector with the most likely sequence of states.
}
\references{
Zucchini and MacDonald (2009). Hidden Markov Models for Time Series: An Introduction Using R.
}
\examples{
#set HMM
tpm0 = matrix(c(0.8,0.2,0.1,0.9),ncol=2,nrow=2,byrow=TRUE)
pList0 = list(c(0.4,0.3,0.3),c(1))
mu0 = c(-4,0,2,10)
sigma0 = c(0.3,0.3,0.3,3)
hmm1 = setHMM(transitionMatrix=tpm0,mu=mu0,sigma=sigma0,probList=pList0)                

#simulate data
dataset = simulateHMM(n=1000,hmm=hmm1)
x = dataset$data
plot(density(x))

#apply viterbi algorithm
viterbiHMM(x=x,hmm=hmm1)

}
\keyword{ viterbi }

\name{investigateMergedHMMs}
\alias{investigateMergedHMMs}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Find density based clusters
}
\description{
This function implements the clustering algorithm using the local decoding entropy (LDE) as proposed in Holzmann and Schwaiger (2013). The HMM and its independence clusters have to be estimated before. To find the independence partition and estimate the model use the function \code{\link[mergeHMM]{findIndependencePartition}}. In order to find the final model plot the values of the LDE, see the example below.
}
\usage{
investigateMergedHMMs(x, hmm, independenceClusters)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{
dataset
}
  \item{hmm}{
an object of type \code{\link[mergeHMM]{hmmClass-class}}, no state-dependent mixtures, since it is the initial model. Typically estimated using the function \code{\link[mergeHMM]{findIndependencePartition}}.
}
  \item{independenceClusters}{
a list, which is a partition of the state space 1,...,k (each list entry is thus a vector), this partition defines the flexibility for merging. Also obtained from \code{\link[mergeHMM]{findIndependencePartition}}, see the example below.
}
}
\value{
a list
\item{modelPath}{a list containing the local decoding optimal model in each step of the iterative algorithm}
\item{GPath}{a list containing the partitions according to the models in the list modelPath}
\item{localDecodingEntropies}{the values of the local decoding entropies}
}
\references{
Holzmann, H. and Schwaiger, F. (2013). Hidden Markov models with state-dependent mixtures: Minimal representation, model testing and applications to clustering.
}

\seealso{
\code{\link[mergeHMM]{findIndependencePartition}}
}
\examples{
#setting an HMM which has independence partition {{1,2,3},{4}}
r1 = c(0.8 * c(1/3,1/3,1/3), 0.2)
r4 = c(0.1 * c(1/3,1/3,1/3), 0.9)
tpm0 = rbind(r1,r1,r1,r4)
mu0 = c(1,4,9,15)
sigma0 = rep(0.8,4)
hmm0= setHMM(transitionMatrix=tpm0,mu=mu0,sigma=sigma0)

#simulating a dataset
set.seed(1)
x = simulateHMM(n=500, hmm=hmm0)$data
plot(density(x))
rug(x)

#find at first independence partition and save it
indepObj= findIndependencePartition(m=4,x=x,alpha=0.01)

estHmm = indepObj$finalModel
estPartition = indepObj$finalG

#find density based cluster using LDE and dependence structure restriction
obj0  = investigateMergedHMMs(x=x,hmm=estHmm,independenceClusters=estPartition)

#seek for an elbow -> second model
plot(obj0$localDecodingEntropies,type="b",pch=19)

finalHmm = obj0$modelPath[[2]] ; finalHmm
#third state could be included (w.r.t. dependence structure), 
#is not since it would not produce a density based cluster,
#LDE finds here the right model...
}
\keyword{ LDE }
\keyword{ local   }
\keyword{ decoding  }
\keyword{ entropy }
\keyword{ cluster }

\name{stat_distr}
\alias{stat_distr}
\title{
Calculating the stationary distribution of a MC}
\description{
This function can be used to calculate the stationary distribution of a given Markov chain (parameterized by a transition probability matrix \code{mat}). 
This function is not written by us (see reference), but very useful when working with the present type of models, and therefore added to the package.
}
\usage{
stat_distr(mat)
}
\arguments{
  \item{mat}{
The tpm of a Markov chain.}
}
\value{
A vector of probabilities, which is the stationary distribution of the Markov chain.}
\references{
Zucchini and MacDonald (2009). Hidden Markov Models for Time Series: An Introduction Using R.}
\author{
Zucchini and MacDonald (2009)
}

\name{findIndependencePartition}
\alias{findIndependencePartition}
\title{
Find independence partition.
}
\description{
This function finds via backward selection the independence partition of the HMM given a dataset, see Holzmann and Schwaiger (2013).
}
\usage{
findIndependencePartition(m, x, alpha = 0.05, estimateIn, details = FALSE, hmm = NULL, ...)
}
\arguments{
  \item{m}{
the number of states of the initial HMM
}
  \item{x}{
the dataset
}
  \item{alpha}{
the level for iterative testing, we recommend 0.01
}
  \item{estimateIn}{
if the initial model is already estimated (which can be time consuming) it can be supplied to the algorithm here
}
  \item{details}{
TRUE/FALSE: controls the output object (how many details)
}
  \item{hmm}{
if estimateIn is not supplied: optionally an object of type \code{\link[mergeHMM]{hmmClass-class}} can be supplied as staring point for iterative optimization of the initial model, otherwise a (unrestricted) starting HMM is calculated using the package RHmm
}
  \item{\dots}{
additional optional parameters passed to \code{\link[mergeHMM]{mleHMM}}
}
}

\value{
a list
\item{pValuePath}{the p-values}
\item{finalModel}{the final model}
\item{finalG}{the according final partition -> the found independence partition}
only if details=TRUE:
\item{modelPath}{a list containing the p-value optimal model in each step of the iterative algorithm}
\item{GPath}{a list containing the partitions according to the models in the list modelPath}
\item{loglikePath}{the values of the log-likelihoods}
\item{likelihoodRatioPath}{the values of the likelihood ratios}
}
\references{
Holzmann, H. and Schwaiger, F. (2013). Hidden Markov models with state-dependent mixtures: Minimal representation, model testing and applications to clustering.
}

\seealso{
\code{\link[mergeHMM]{investigateMergedHMMs}}
}
\examples{
#setting an HMM which has independence partition {{1,2,3},{4}}
r1 = c(0.8 * c(1/3,1/3,1/3), 0.2)
r4 = c(0.1 * c(1/3,1/3,1/3), 0.9)
tpm0 = rbind(r1,r1,r1,r4)
mu0 = c(1,4,9,15)
sigma0 = rep(0.8,4)
hmm0= setHMM(transitionMatrix=tpm0,mu=mu0,sigma=sigma0)

#simulating a dataset
set.seed(1)
x = simulateHMM(n=500, hmm=hmm0)$data
plot(density(x))
rug(x)

#find at first independence partition and save it
indepObj= findIndependencePartition(m=4,x=x,alpha=0.01)

estHmm = indepObj$finalModel
estPartition = indepObj$finalG

#find density based cluster using LDE and dependence structure restriction
obj0  = investigateMergedHMMs(x=x,hmm=estHmm,independenceClusters=estPartition)

#seek for an elbow -> second model
plot(obj0$localDecodingEntropies,type="b",pch=19)

finalHmm = obj0$modelPath[[2]] ; finalHmm
#third state could be included (w.r.t. dependence structure), 
#is not since it would not produce a density based cluster,
#LDE finds here the right model...
}
\keyword{ hmm }
\keyword{ independence }
\keyword{ partition }
\keyword{ cluster }

\name{mleHMM}
\alias{mleHMM}

\title{
Estimating (restricted) HMMs.
}
\description{
This function estimates the (restricted) MLE given a dataset. If restrictions to the dependence structure should be applied, this can be done via the argument G, see the details section and the examples.
}
\usage{
mleHMM(x, m, G = as.list(1:m), hmm = NULL, ...)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{x}{
the dataset. If it is a vector the univariate normal distribution is used, if it is a matrix (dimensions row-wise) the multivariate normal distribution is used.
}
  \item{m}{
number of states of the Markov chain
}
  \item{G}{
optionally a list, which is a partition of the state space 1,...,k (each list entry is thus a vector). This implies a restriction on the dependence structure, see below.
}
  \item{hmm}{
optionally an object of type \code{\link[mergeHMM]{hmmClass-class}} can be supplied as staring point for iterative optimization, otherwise a (unrestricted) starting HMM is calculated using the package RHmm
}
  \item{\dots}{
If no starting parameter for optimization is supplied (hmm=NULL), then the starting parameter is calculated by using the function HMMfit of the package RHmm by fitting an unristricted HMM. Thus this argument can be used to pass additional control parameters to the function HMMFit, see the help file for further details on that.

If a starting HMM is supplied, then this argument can be used to pass additional parameter to nlm, which calculates iteratively the restricted MLE, see the help file of nlm for further details.
}
}
\details{
With the argument G restrictions to the transition matrix can be applied. Using G = as.list(1:m) gives an unrestricted usual HMM, using G = list(1:m) gives an i.i.d. model. All cases in between are also possible, see the example below. When using restricted estimation a starting value should be supplied because of possible label switching, e.g. by unrestricted estimation before (see example below). 
}
\value{
A list with entries
\item{mle}{object of type \code{\link[mergeHMM]{hmmClass-class}}}
\item{code}{convergence-flag of nlm}
\item{mllk}{value of optimal minus log-likelihood}
\item{AIC}{AIC}
\item{BIC}{BIC}
}


\seealso{
\code{\link{nlm}} and \code{\link[RHmm]{HMMFit}}
}
\examples{
#setting an HMM which has independence partition {{1,2},{3}}
r1 = c(0.8 * c(0.5,0.5), 0.2)
r3 = c(0.1 * c(0.5,0.5), 0.9)
tpm0 = rbind(r1,r1,r3)
mu0 = c(1,3,7)
sigma0 = rep(0.8,3)
hmm0= setHMM(transitionMatrix=tpm0,mu=mu0,sigma=sigma0)

#simulating a dataset
set.seed(1)
x = simulateHMM(n=500, hmm=hmm0)$data

#estimate unrestricted HMM
mle0 = mleHMM(x=x,m=3); mle0

#estimate with correct restriction
mle1 = mleHMM(x=x,m=3,G=list(1:2,3),hmm=mle0$mle); mle1

#estimate with wrong restriction
mle2 = mleHMM(x=x,m=3,G=list(1,2:3),hmm=mle0$mle); mle2

}
% Add one or more standard keywords, see file 'KEYWORDS' in the
% R documentation directory.
\keyword{ ~kwd1 }
\keyword{ ~kwd2 }% __ONLY ONE__ keyword per line

\name{mergeHMM}
\alias{mergeHMM}
%- Also NEED an '\alias' for EACH other topic documented here.
\title{
Merging a hidden Markov model.
}
\description{
This page documents the function \code{mergeHMM}. For the package overview see \code{\link[mergeHMM]{mergeHMM-package}}.

The function \code{mergeHMM} merges states of an HMM given a partition of the state space 1,...,k of the according hidden Markov chain, i.e. an HMM is mapped onto a new HMM. Note that the given partition should divide the state space into r<k groups. The new HMM has a transition probability matrix with entries being the transition probabilities between the groups of the given partition w.r.t. the input transition probability matrix. The new state dependent distributions are given by mixtures of the input state dependent distributions, whereas the mixture proportions are given by the (stationary) conditional state probabilities within the according group, see the reference and the example below.
}
\usage{
mergeHMM(hmm, G)
}
\arguments{
  \item{hmm}{
an object of type \code{\link[mergeHMM]{hmmClass-class}}. For creating such an object use \code{\link[mergeHMM]{setHMM}} or functions which estimate it, i.e. \code{\link[mergeHMM]{findIndependencePartition}}.
}
  \item{G}{
a list, which is a partition of the state space 1,...,k (each list entry is thus a vector), see the example below.
}
}
\details{
Consider the input HMM to have k states. Than the partition \code{G} has to be a list with r<k entries, whereas each list entry (an integer vector) represents a group of states being a subset of the state space 1,...,k. All list entries have to be disjoint. The output HMM has r states. The transition probability matrix is given by the group transition probabilities induced by the input transition matrix and the groups given by \code{G}. As described above the state-dependent distributions of the merged model are mixtures given by the (stationary) state probabilities within the groups.

The observable process of the resulting HMM has exactly the same distribution as the observable part of a reduced HMM, which can be found using the function \code{\link[mergeHMM]{reduceHMM}}. The difference between both models is only the state interpretation: In the reduced HMM we still deal with k states. In case of merging the latent mixture states are not interpreted as states anymore and the mapping results in an r state HMM. 

Note, that both functions in general change the time-series model. Only iff the transition matrix has a special structure the probabilistic structure of the observable process in both cases is not changed. To check whether a transition matrix possesses has this structure, it simply has to be checked if the matrix does not change when the function \code{\link[mergeHMM]{reduceTpm}} is applied. For more theoretical background see the paper below. 
}
\value{
an object of type \code{\link[mergeHMM]{hmmClass-class}}.
}
\references{
Holzmann, H. and Schwaiger, F. (2013). Hidden Markov models with state-dependent mixtures: Minimal representation, model testing and applications to clustering.
}

\note{
The merged HMM is here NOT estimated in the restricted parameter space. No dataset is needed, it is simply a mapping of the model. For estimating under the restriction that state dependent distributions are mixtures, use the function \code{\link[mergeHMM]{mleHMM}} and see the the examples there.
}

%% ~Make other sections like Warning with \section{Warning }{....} ~

\seealso{
\code{\link[mergeHMM]{mergeHMM-package}}, \code{\link[mergeHMM]{mleHMM}}, \code{\link[mergeHMM]{reduceHMM}}, \code{\link[mergeHMM]{reduceTpm}} and \code{\link[mergeHMM]{setHMM}}.
}
\examples{
#first example:
#  setting a five state HMM with strongly persistent structure in the hidden Markov chain
#  the dependence structure will change under merging or reducing

#settinng the input HMM (five states)
tpm1 = matrix(c(0.92,0.02,0.02,0.02,0.02,
                0.02,0.92,0.02,0.02,0.02,
                0.02,0.02,0.92,0.02,0.02,
                0.02,0.02,0.02,0.92,0.02,
                0.02,0.02,0.02,0.02,0.92),ncol=5,nrow=5,byrow=TRUE)
mu0 = c(1,3,6,10,15)
sigma0 = rep(1,5)
hmmIn = setHMM(transitionMatrix=tpm1,mu=mu0,sigma=sigma0)

#setting a partition 
# -> sets states 1 and 2, 3 and 4 and 5 each to one group  
G_in = list(1:2,3:4,5)

mergeHMM(hmm=hmmIn,G=G_in)
reduceHMM(hmm=hmmIn,G=G_in) # tpm does change in comparison to tpm1!

#second example:
#  setting a five state HMM with potential for merging
#  the dependence structure of the model will not change under merging or reducing
r12 = c( 0.7 * c(0.9,0.1), 0.2  * c(0.2,0.8), 0.1  )
r34 = c( 0.1 * c(0.9,0.1), 0.8  * c(0.2,0.8), 0.1  )
r5   = c( 0.1 * c(0.9,0.1), 0.05 * c(0.2,0.8), 0.85  )

tpm2 = rbind(r12,r12,r34,r34,r5)
hmmIn2 = setHMM(transitionMatrix=tpm2,mu=mu0,sigma=sigma0)


mergeHMM(hmm=hmmIn2,G=G_in)
reduceHMM(hmm=hmmIn2,G=G_in) # tpm does NOT change in comparison to tpm2!
}
\keyword{ merging }
\keyword{ reducing }
